library ieee;
use ieee.std_logic_1164.all;
entity MULT18X18S_PLUS is
 port(	A_INPUT, B_INPUT:in std_logic_vector(17 downto 0);
	CLK, RST, CE: in std_logic;
	P_OUTPUT: out std_logic_vector(35 downto 0));
end MULT18X18S_PLUS;

architecture MULT18X18S_PLUS_BEHAVIOR of MULT18X18S_PLUS is
component FDR
   port(
      Q                              :	out   STD_ULOGIC;
      D                              :	in    STD_ULOGIC;
      C                              :	in    STD_ULOGIC;
      R                              :	in    STD_ULOGIC);
end component;      
component MULT18X18S
    port (A	: in STD_LOGIC_VECTOR (17 downto 0);
          B	: in STD_LOGIC_VECTOR (17 downto 0);
          C	: in STD_ULOGIC ;
          CE	: in STD_ULOGIC ;
	  P	: out STD_LOGIC_VECTOR (35 downto 0);
          R 	: in STD_ULOGIC );
end component;

signal a_wire, b_wire: std_logic_vector(17 downto 0);
signal p_wire: std_logic_vector(35 downto 0);

attribute RLOC : string;

attribute RLOC of REG_A0 : label is "X0Y0" ;
attribute RLOC of REG_A1 : label is "X0Y0" ;
attribute RLOC of REG_A2 : label is "X0Y1" ;
attribute RLOC of REG_A3 : label is "X0Y1" ;
attribute RLOC of REG_A4 : label is "X0Y2" ;
attribute RLOC of REG_A5 : label is "X0Y2" ;
attribute RLOC of REG_A6 : label is "X0Y3" ;
attribute RLOC of REG_A7 : label is "X0Y3" ;
attribute RLOC of REG_A8 : label is "X0Y4" ;
attribute RLOC of REG_A9 : label is "X0Y4" ;
attribute RLOC of REG_A10: label is "X0Y5" ;
attribute RLOC of REG_A11: label is "X0Y5" ;
attribute RLOC of REG_A12: label is "X0Y6" ;
attribute RLOC of REG_A13: label is "X0Y6" ;
attribute RLOC of REG_A14: label is "X0Y7" ;
attribute RLOC of REG_A15: label is "X0Y7" ;
attribute RLOC of REG_A16: label is "X-1Y7";
attribute RLOC of REG_A17: label is "X-1Y7";
                                           
attribute RLOC of REG_B0 : label is "X2Y0" ;
attribute RLOC of REG_B1 : label is "X2Y0" ;
attribute RLOC of REG_B2 : label is "X2Y1" ;
attribute RLOC of REG_B3 : label is "X2Y1" ;
attribute RLOC of REG_B4 : label is "X2Y2" ;
attribute RLOC of REG_B5 : label is "X2Y2" ;
attribute RLOC of REG_B6 : label is "X2Y3" ;
attribute RLOC of REG_B7 : label is "X2Y3" ;
attribute RLOC of REG_B8 : label is "X2Y4" ;
attribute RLOC of REG_B9 : label is "X2Y4" ;
attribute RLOC of REG_B10: label is "X2Y5" ;
attribute RLOC of REG_B11: label is "X2Y5" ;
attribute RLOC of REG_B12: label is "X2Y6" ;
attribute RLOC of REG_B13: label is "X2Y6" ;
attribute RLOC of REG_B14: label is "X2Y7" ;
attribute RLOC of REG_B15: label is "X2Y7" ;
attribute RLOC of REG_B16: label is "X-1Y6";
attribute RLOC of REG_B17: label is "X-1Y6";

attribute RLOC of REG_P0 : label is "X-2Y0";
attribute RLOC of REG_P1 : label is "X1Y0" ;
attribute RLOC of REG_P2 : label is "X1Y0" ;
attribute RLOC of REG_P3 : label is "X1Y1" ;
attribute RLOC of REG_P4 : label is "X1Y1" ;
attribute RLOC of REG_P5 : label is "X3Y0" ;
attribute RLOC of REG_P6 : label is "X3Y0" ;
attribute RLOC of REG_P7 : label is "X3Y1" ;
attribute RLOC of REG_P8 : label is "X-2Y2";
attribute RLOC of REG_P9 : label is "X1Y2" ;
attribute RLOC of REG_P10: label is "X1Y2" ;
attribute RLOC of REG_P11: label is "X1Y3" ;
attribute RLOC of REG_P12: label is "X1Y3" ;
attribute RLOC of REG_P13: label is "X3Y2" ;
attribute RLOC of REG_P14: label is "X3Y2" ;
attribute RLOC of REG_P15: label is "X3Y3" ;
attribute RLOC of REG_P16: label is "X-2Y4";
attribute RLOC of REG_P17: label is "X1Y4" ;
attribute RLOC of REG_P18: label is "X1Y4" ;
attribute RLOC of REG_P19: label is "X1Y5" ;
attribute RLOC of REG_P20: label is "X1Y5" ;
attribute RLOC of REG_P21: label is "X3Y4" ;
attribute RLOC of REG_P22: label is "X3Y4" ;
attribute RLOC of REG_P23: label is "X3Y5" ;
attribute RLOC of REG_P24: label is "X-2Y6";
attribute RLOC of REG_P25: label is "X1Y6" ;
attribute RLOC of REG_P26: label is "X1Y6" ;
attribute RLOC of REG_P27: label is "X1Y7" ;
attribute RLOC of REG_P28: label is "X1Y7" ;
attribute RLOC of REG_P29: label is "X3Y6" ;
attribute RLOC of REG_P30: label is "X3Y6" ;
attribute RLOC of REG_P31: label is "X3Y7" ;
attribute RLOC of REG_P32: label is "X3Y1" ;
attribute RLOC of REG_P33: label is "X3Y3" ;
attribute RLOC of REG_P34: label is "X3Y5" ;
attribute RLOC of REG_P35: label is "X3Y7" ;

attribute BEL : string;

attribute BEL of REG_A0 : label is "FFX" ;
attribute BEL of REG_A1 : label is "FFY" ;
attribute BEL of REG_A2 : label is "FFX" ;
attribute BEL of REG_A3 : label is "FFY" ;
attribute BEL of REG_A4 : label is "FFX" ;
attribute BEL of REG_A5 : label is "FFY" ;
attribute BEL of REG_A6 : label is "FFX" ;
attribute BEL of REG_A7 : label is "FFY" ;
attribute BEL of REG_A8 : label is "FFX" ;
attribute BEL of REG_A9 : label is "FFY" ;
attribute BEL of REG_A10: label is "FFX" ;
attribute BEL of REG_A11: label is "FFY" ;
attribute BEL of REG_A12: label is "FFX" ;
attribute BEL of REG_A13: label is "FFY" ;
attribute BEL of REG_A14: label is "FFX" ;
attribute BEL of REG_A15: label is "FFY" ;
attribute BEL of REG_A16: label is "FFX" ;
attribute BEL of REG_A17: label is "FFY" ;
                                    
attribute BEL of REG_B0 : label is "FFX" ;
attribute BEL of REG_B1 : label is "FFY" ;
attribute BEL of REG_B2 : label is "FFX" ;
attribute BEL of REG_B3 : label is "FFY" ;
attribute BEL of REG_B4 : label is "FFX" ;
attribute BEL of REG_B5 : label is "FFY" ;
attribute BEL of REG_B6 : label is "FFX" ;
attribute BEL of REG_B7 : label is "FFY" ;
attribute BEL of REG_B8 : label is "FFX" ;
attribute BEL of REG_B9 : label is "FFY" ;
attribute BEL of REG_B10: label is "FFX" ;
attribute BEL of REG_B11: label is "FFY" ;
attribute BEL of REG_B12: label is "FFX" ;
attribute BEL of REG_B13: label is "FFY" ;
attribute BEL of REG_B14: label is "FFX" ;
attribute BEL of REG_B15: label is "FFY" ;
attribute BEL of REG_B16: label is "FFX" ;
attribute BEL of REG_B17: label is "FFY" ;
                              
attribute BEL of REG_P0 : label is "FFY" ;
attribute BEL of REG_P1 : label is "FFX" ;
attribute BEL of REG_P2 : label is "FFY" ;
attribute BEL of REG_P3 : label is "FFX" ;
attribute BEL of REG_P4 : label is "FFY" ;
attribute BEL of REG_P5 : label is "FFX" ;
attribute BEL of REG_P6 : label is "FFY" ;
attribute BEL of REG_P7 : label is "FFX" ;
attribute BEL of REG_P8 : label is "FFY" ;
attribute BEL of REG_P9 : label is "FFX" ;
attribute BEL of REG_P10: label is "FFY" ;
attribute BEL of REG_P11: label is "FFX" ;
attribute BEL of REG_P12: label is "FFY" ;
attribute BEL of REG_P13: label is "FFX" ;
attribute BEL of REG_P14: label is "FFY" ;
attribute BEL of REG_P15: label is "FFX" ;
attribute BEL of REG_P16: label is "FFY" ;
attribute BEL of REG_P17: label is "FFX" ;
attribute BEL of REG_P18: label is "FFY" ;
attribute BEL of REG_P19: label is "FFX" ;
attribute BEL of REG_P20: label is "FFY" ;
attribute BEL of REG_P21: label is "FFX" ;
attribute BEL of REG_P22: label is "FFY" ;
attribute BEL of REG_P23: label is "FFX" ;
attribute BEL of REG_P24: label is "FFY" ;
attribute BEL of REG_P25: label is "FFX" ;
attribute BEL of REG_P26: label is "FFY" ;
attribute BEL of REG_P27: label is "FFX" ;
attribute BEL of REG_P28: label is "FFY" ;
attribute BEL of REG_P29: label is "FFX" ;
attribute BEL of REG_P30: label is "FFY" ;
attribute BEL of REG_P31: label is "FFX" ;
attribute BEL of REG_P32: label is "FFY" ;
attribute BEL of REG_P33: label is "FFY" ;
attribute BEL of REG_P34: label is "FFY" ;
attribute BEL of REG_P35: label is "FFY" ;
                                      

begin

REG_A0  : FDR port map(Q => a_wire(0)  , C => CLK, D => A_INPUT(0)  , R => RST);
REG_A1  : FDR port map(Q => a_wire(1)  , C => CLK, D => A_INPUT(1)  , R => RST);
REG_A2  : FDR port map(Q => a_wire(2)  , C => CLK, D => A_INPUT(2)  , R => RST);
REG_A3  : FDR port map(Q => a_wire(3)  , C => CLK, D => A_INPUT(3)  , R => RST);
REG_A4  : FDR port map(Q => a_wire(4)  , C => CLK, D => A_INPUT(4)  , R => RST);
REG_A5  : FDR port map(Q => a_wire(5)  , C => CLK, D => A_INPUT(5)  , R => RST);
REG_A6  : FDR port map(Q => a_wire(6)  , C => CLK, D => A_INPUT(6)  , R => RST);
REG_A7  : FDR port map(Q => a_wire(7)  , C => CLK, D => A_INPUT(7)  , R => RST);
REG_A8  : FDR port map(Q => a_wire(8)  , C => CLK, D => A_INPUT(8)  , R => RST);
REG_A9  : FDR port map(Q => a_wire(9)  , C => CLK, D => A_INPUT(9)  , R => RST);
REG_A10 : FDR port map(Q => a_wire(10) , C => CLK, D => A_INPUT(10) , R => RST);
REG_A11 : FDR port map(Q => a_wire(11) , C => CLK, D => A_INPUT(11) , R => RST);
REG_A12 : FDR port map(Q => a_wire(12) , C => CLK, D => A_INPUT(12) , R => RST);
REG_A13 : FDR port map(Q => a_wire(13) , C => CLK, D => A_INPUT(13) , R => RST);
REG_A14 : FDR port map(Q => a_wire(14) , C => CLK, D => A_INPUT(14) , R => RST);
REG_A15 : FDR port map(Q => a_wire(15) , C => CLK, D => A_INPUT(15) , R => RST);
REG_A16 : FDR port map(Q => a_wire(16) , C => CLK, D => A_INPUT(16) , R => RST);
REG_A17 : FDR port map(Q => a_wire(17) , C => CLK, D => A_INPUT(17) , R => RST);
                                                                               
REG_B0  : FDR port map(Q => b_wire(0)  , C => CLK, D => B_INPUT(0)  , R => RST);
REG_B1  : FDR port map(Q => b_wire(1)  , C => CLK, D => B_INPUT(1)  , R => RST);
REG_B2  : FDR port map(Q => b_wire(2)  , C => CLK, D => B_INPUT(2)  , R => RST);
REG_B3  : FDR port map(Q => b_wire(3)  , C => CLK, D => B_INPUT(3)  , R => RST);
REG_B4  : FDR port map(Q => b_wire(4)  , C => CLK, D => B_INPUT(4)  , R => RST);
REG_B5  : FDR port map(Q => b_wire(5)  , C => CLK, D => B_INPUT(5)  , R => RST);
REG_B6  : FDR port map(Q => b_wire(6)  , C => CLK, D => B_INPUT(6)  , R => RST);
REG_B7  : FDR port map(Q => b_wire(7)  , C => CLK, D => B_INPUT(7)  , R => RST);
REG_B8  : FDR port map(Q => b_wire(8)  , C => CLK, D => B_INPUT(8)  , R => RST);
REG_B9  : FDR port map(Q => b_wire(9)  , C => CLK, D => B_INPUT(9)  , R => RST);
REG_B10 : FDR port map(Q => b_wire(10) , C => CLK, D => B_INPUT(10) , R => RST);
REG_B11 : FDR port map(Q => b_wire(11) , C => CLK, D => B_INPUT(11) , R => RST);
REG_B12 : FDR port map(Q => b_wire(12) , C => CLK, D => B_INPUT(12) , R => RST);
REG_B13 : FDR port map(Q => b_wire(13) , C => CLK, D => B_INPUT(13) , R => RST);
REG_B14 : FDR port map(Q => b_wire(14) , C => CLK, D => B_INPUT(14) , R => RST);
REG_B15 : FDR port map(Q => b_wire(15) , C => CLK, D => B_INPUT(15) , R => RST);
REG_B16 : FDR port map(Q => b_wire(16) , C => CLK, D => B_INPUT(16) , R => RST);
REG_B17 : FDR port map(Q => b_wire(17) , C => CLK, D => B_INPUT(17) , R => RST);

test_mult18x18s : MULT18X18S port map(P => p_wire, A => a_wire, B => b_wire, C => CLK, CE => CE, R => RST);

REG_P0  : FDR port map(Q => P_OUTPUT(0)  , C => CLK, D => p_wire(0)  , R => RST);
REG_P1  : FDR port map(Q => P_OUTPUT(1)  , C => CLK, D => p_wire(1)  , R => RST);
REG_P2  : FDR port map(Q => P_OUTPUT(2)  , C => CLK, D => p_wire(2)  , R => RST);
REG_P3  : FDR port map(Q => P_OUTPUT(3)  , C => CLK, D => p_wire(3)  , R => RST);
REG_P4  : FDR port map(Q => P_OUTPUT(4)  , C => CLK, D => p_wire(4)  , R => RST);
REG_P5  : FDR port map(Q => P_OUTPUT(5)  , C => CLK, D => p_wire(5)  , R => RST);
REG_P6  : FDR port map(Q => P_OUTPUT(6)  , C => CLK, D => p_wire(6)  , R => RST);
REG_P7  : FDR port map(Q => P_OUTPUT(7)  , C => CLK, D => p_wire(7)  , R => RST);
REG_P8  : FDR port map(Q => P_OUTPUT(8)  , C => CLK, D => p_wire(8)  , R => RST);
REG_P9  : FDR port map(Q => P_OUTPUT(9)  , C => CLK, D => p_wire(9)  , R => RST);
REG_P10 : FDR port map(Q => P_OUTPUT(10) , C => CLK, D => p_wire(10) , R => RST);
REG_P11 : FDR port map(Q => P_OUTPUT(11) , C => CLK, D => p_wire(11) , R => RST);
REG_P12 : FDR port map(Q => P_OUTPUT(12) , C => CLK, D => p_wire(12) , R => RST);
REG_P13 : FDR port map(Q => P_OUTPUT(13) , C => CLK, D => p_wire(13) , R => RST);
REG_P14 : FDR port map(Q => P_OUTPUT(14) , C => CLK, D => p_wire(14) , R => RST);
REG_P15 : FDR port map(Q => P_OUTPUT(15) , C => CLK, D => p_wire(15) , R => RST);
REG_P16 : FDR port map(Q => P_OUTPUT(16) , C => CLK, D => p_wire(16) , R => RST);
REG_P17 : FDR port map(Q => P_OUTPUT(17) , C => CLK, D => p_wire(17) , R => RST);
REG_P18 : FDR port map(Q => P_OUTPUT(18) , C => CLK, D => p_wire(18) , R => RST);
REG_P19 : FDR port map(Q => P_OUTPUT(19) , C => CLK, D => p_wire(19) , R => RST);
REG_P20 : FDR port map(Q => P_OUTPUT(20) , C => CLK, D => p_wire(20) , R => RST);
REG_P21 : FDR port map(Q => P_OUTPUT(21) , C => CLK, D => p_wire(21) , R => RST);
REG_P22 : FDR port map(Q => P_OUTPUT(22) , C => CLK, D => p_wire(22) , R => RST);
REG_P23 : FDR port map(Q => P_OUTPUT(23) , C => CLK, D => p_wire(23) , R => RST);
REG_P24 : FDR port map(Q => P_OUTPUT(24) , C => CLK, D => p_wire(24) , R => RST);
REG_P25 : FDR port map(Q => P_OUTPUT(25) , C => CLK, D => p_wire(25) , R => RST);
REG_P26 : FDR port map(Q => P_OUTPUT(26) , C => CLK, D => p_wire(26) , R => RST);
REG_P27 : FDR port map(Q => P_OUTPUT(27) , C => CLK, D => p_wire(27) , R => RST);
REG_P28 : FDR port map(Q => P_OUTPUT(28) , C => CLK, D => p_wire(28) , R => RST);
REG_P29 : FDR port map(Q => P_OUTPUT(29) , C => CLK, D => p_wire(29) , R => RST);
REG_P30 : FDR port map(Q => P_OUTPUT(30) , C => CLK, D => p_wire(30) , R => RST);
REG_P31 : FDR port map(Q => P_OUTPUT(31) , C => CLK, D => p_wire(31) , R => RST);
REG_P32 : FDR port map(Q => P_OUTPUT(32) , C => CLK, D => p_wire(32) , R => RST);
REG_P33 : FDR port map(Q => P_OUTPUT(33) , C => CLK, D => p_wire(33) , R => RST);
REG_P34 : FDR port map(Q => P_OUTPUT(34) , C => CLK, D => p_wire(34) , R => RST);
REG_P35 : FDR port map(Q => P_OUTPUT(35) , C => CLK, D => p_wire(35) , R => RST);

end MULT18X18S_PLUS_BEHAVIOR;
